package com.inca.npbusi.credit_cancel;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.NVPair;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.StringCommand;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.util.SendHelper;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.pubsrv.entryChoose.EntryChoosable;
import com.inca.pubsrv.work_flow.CDetailModel_WorkFlow;
import java.awt.event.ActionEvent;
import java.util.Iterator;

public class CreditCancel_detail extends CDetailModel_WorkFlow {
   public CreditCancel_detail(CFrame var1, CMdeModel var2) {
      super(var1, "信誉额度取消细单", var2);
   }

   public String getTablename() {
      return "bms_credit_cancel_dtl_v";
   }

   public String getHovOtherWheres(int var1, String var2) {
      String var3 = this.mdemodel.getMasterModel().getItemValue(this.mdemodel.getMasterModel().getRow(), "entryid");
      String var4;
      if (var2.equalsIgnoreCase("saleropcode")) {
         var4 = this.getItemValue(var1, "customid");
         var4 = "employeeid in(select salerid from pub_custom_to_saler" + (var4.length() > 0 ? " where customid=" + var4 + " and entryid=" + var3 : " where entryid=" + var3) + ")";
         return var4 + " and get_entryid_by_deptid(deptid)=" + ((EntryChoosable)this.mdemodel.getMasterModel()).getEntry().getEntryid();
      } else if (var2.equalsIgnoreCase("customopcode")) {
         var4 = this.getItemValue(var1, "salerid");
         return "customid in(select customid from pub_custom_to_saler" + (var4.length() > 0 ? " where salerid=" + var4 + " and entryid=" + var3 : " where entryid=" + var3) + ")";
      } else {
         return super.getHovOtherWheres(var1, var2);
      }
   }

   protected String getEditablecolumns(int var1) {
      if (this.on_beforemodify(var1) < 0) {
         return "";
      } else {
         String var2 = ((CMdeModelAp)this.mdemodel).getApvalue("调整项目");
         String var3 = "";
         if (!var2.equals("只调整额度") && !var2.equals("只调整天数")) {
            var3 = ",adjustItem";
         }

         this.getItemValue(var1, "adjustItem");
         var2 = var3;
         if ((var3 = this.getItemValue(var1, "credit_level")).equals("")) {
            return "credit_level,dtlmemo" + var2;
         } else if (!var3.equals("1") && !var3.equals("3")) {
            if (!var3.equals("2") && !var3.equals("4")) {
               return !var3.equals("5") && !var3.equals("6") ? super.getEditablecolumns(var1) : "credit_level,dtlmemo,customopcode" + var2;
            } else {
               return "credit_level,dtlmemo,saleropcode" + var2;
            }
         } else {
            return "credit_level,dtlmemo,saleropcode,customopcode" + var2;
         }
      }
   }

   protected void on_itemvaluechange(int var1, String var2, String var3) {
      if (var2.equalsIgnoreCase("credit_level")) {
         if (!var3.equals("1") && !var3.equals("3")) {
            if (!var3.equals("2") && !var3.equals("4")) {
               if (var3.equals("5")) {
                  this.setItemValue(var1, "saleropcode", "");
                  this.setItemValue(var1, "salername", "");
                  this.setItemValue(var1, "salerid", "");
               } else if ("6".equals(var3)) {
                  this.setItemValue(var1, "saleropcode", "");
               }
            } else {
               this.setItemValue(var1, "customopcode", "");
               this.setItemValue(var1, "customname", "");
               this.setItemValue(var1, "customid", "");
            }
         } else {
            this.setItemValue(var1, "saleropcode", "");
            this.setItemValue(var1, "salername", "");
            this.setItemValue(var1, "salerid", "");
            this.setItemValue(var1, "customopcode", "");
            this.setItemValue(var1, "customname", "");
            this.setItemValue(var1, "customid", "");
         }
      } else if (!var2.equalsIgnoreCase("salerid") && !var2.equalsIgnoreCase("customid") && var2.equalsIgnoreCase("adjustitem")) {
         if (var3.equals("1")) {
            this.setItemValue(var1, "days", "");
         } else if (var3.equals("2")) {
            this.setItemValue(var1, "credit", "");
         } else {
            this.setItemValue(var1, var2, var3);
         }
      }

      super.on_itemvaluechange(var1, var2, var3);
   }

   protected int on_checkrow(int var1, DBTableModel var2) {
      String var3 = this.getItemValue(var1, "credit_level");
      String var4 = this.getItemValue(var1, "salerid");
      String var5 = this.getItemValue(var1, "customid");
      if (var3.equals("")) {
         this.infoMessage("细单提示", "信誉额度级别必须要填写！");
         this.setFocus("credit_level");
         return -1;
      } else if (!var3.equals("1") && !var3.equals("3") || !var4.equals("") && !var5.equals("")) {
         if ((var3.equals("2") || var3.equals("4")) && var4.equals("")) {
            this.infoMessage("细单提示", "业务员必须要填写！");
            this.setFocus("salerid");
            return -1;
         } else if (var3.equals("5") && var5.equals("")) {
            this.infoMessage("细单提示", "客户必须要填写！");
            this.setFocus("customid");
            return -1;
         } else {
            return super.on_checkrow(var1, var2);
         }
      } else {
         this.infoMessage("细单提示", "业务员和客户必须要填写！");
         this.setFocus("customid");
         return -1;
      }
   }

   protected int on_new(int var1) {
      this.setItemValue(var1, "usestatus", "1");
      String var2;
      if ((var2 = ((CMdeModelAp)this.mdemodel).getApvalue("调整项目")).equals("只调整额度")) {
         this.setItemValue(var1, "adjustitem", "1");
      } else if (var2.equals("只调整天数")) {
         this.setItemValue(var1, "adjustitem", "2");
      } else {
         this.setItemValue(var1, "adjustitem", "3");
      }

      return super.on_new(var1);
   }

   public void actionPerformed(ActionEvent var1) {
      if ("执行".equals(var1.getActionCommand())) {
         CreditCancel_detail var2 = this;
         if (!((CMdeModelAp)this.mdemodel).getApvalue("执行").equals("1")) {
            this.infoMessage("细单提示", "没有执行权限");
         } else {
            ParamCommand var3;
            (var3 = new ParamCommand()).addParam("action", "执行");
            int[] var4;
            if ((var4 = this.table.getSelectedRows()).length == 0) {
               this.infoMessage("细单提示", "请多选细单");
            } else {
               int var5 = 0;

               while(true) {
                  if (var5 >= var4.length) {
                     ClientRequest var9;
                     (var9 = new ClientRequest("sa.CreditCancel.后台服务")).addCommand(var3);

                     try {
                        StringCommand var7;
                        if (!(var7 = (StringCommand)SendHelper.sendRequest(var9).commandAt(0)).getString().startsWith("+")) {
                           throw new Exception(var7.getString());
                        }

                        for(int var8 = 0; var8 < var4.length; ++var8) {
                           var2.setItemValue(var4[var8], "usestatus", "4");
                           var2.getDBtableModel().setdbStatus(var4[var8], 0);
                           var2.getDBtableModel().getRecordThunk(var4[var8]).setSaveresult(0, "执行成功");
                        }

                        var2.tableChanged();
                        var2.infoMessage("细单提示", "执行操作完成");
                     } catch (Exception var6) {
                        var2.infoMessage("执行操作失败", var6.getMessage());
                     }
                     break;
                  }

                  if (!var2.getItemValue(var4[var5], "usestatus").equals("3")) {
                     var2.infoMessage("细单提示", "第" + (var4[var5] + 1) + "行细单不是正式状态");
                     break;
                  }

                  if (var2.getdbStatus(var4[var5]) != 0) {
                     var2.infoMessage("细单提示", "第" + (var4[var5] + 1) + "行细单没有保存");
                     break;
                  }

                  var3.addParam("i" + var5, var2.getItemValue(var4[var5], "creditcanceldtlid"));
                  ++var5;
               }
            }
         }
      } else if ("作废".equals(var1.getActionCommand())) {
         this.a();
      }

      super.actionPerformed(var1);
   }

   protected int on_beforedel(int var1) {
      if (super.on_beforedel(var1) < 0) {
         return -1;
      } else if (this.getdbStatus(var1) != 1 && !this.getItemValue(var1, "usestatus").equals("1")) {
         return -1;
      } else {
         return !this.b() ? -1 : 0;
      }
   }

   protected int on_beforeNew() {
      return !this.b() ? -1 : super.on_beforeNew();
   }

   protected int on_beforemodify(int var1) {
      if (!this.b()) {
         return -1;
      } else if (super.on_beforemodify(var1) < 0) {
         return -1;
      } else {
         return this.getdbStatus(var1) != 1 && !this.getItemValue(var1, "usestatus").equals("1") ? -1 : 0;
      }
   }

   private void a() {
      int[] var1;
      if ((var1 = this.table.getSelectedRows()).length == 0) {
         this.infoMessage("细单提示", "请多选细单");
      } else if (!this.b()) {
         this.infoMessage("细单提示", "不是你录入的单据，不能作废");
      } else {
         ParamCommand var2;
         (var2 = new ParamCommand()).addParam("action", "作废");

         for(int var3 = 0; var3 < var1.length; ++var3) {
            if (!this.getItemValue(var1[var3], "usestatus").equals("1")) {
               this.infoMessage("细单提示", "第" + (var1[var3] + 1) + "行细单不是临时状态");
               return;
            }

            if (this.getdbStatus(var1[var3]) != 0) {
               this.infoMessage("细单提示", "第" + (var1[var3] + 1) + "行细单没有保存");
               return;
            }

            var2.addParam("i" + var3, this.getItemValue(var1[var3], "creditcanceldtlid"));
         }

         ClientRequest var7;
         (var7 = new ClientRequest("sa.CreditCancel.后台服务")).addCommand(var2);

         try {
            StringCommand var5;
            if (!(var5 = (StringCommand)SendHelper.sendRequest(var7).commandAt(0)).getString().startsWith("+")) {
               throw new Exception(var5.getString());
            } else {
               for(int var6 = 0; var6 < var1.length; ++var6) {
                  this.setItemValue(var1[var6], "usestatus", "0");
                  this.setdbStatus(var1[var6], 0);
               }

               this.infoMessage("细单提示", "作废操作完成");
            }
         } catch (Exception var4) {
            this.infoMessage("作废操作失败", var4.getMessage());
         }
      }
   }

   private boolean b() {
      int var1;
      return (var1 = this.mdemodel.getMasterModel().getRow()) < 0 ? false : this.mdemodel.getMasterModel().getItemValue(var1, "inputmanid").equals(ClientUserManager.getCurrentUser().getUserid());
   }

   public ParamCommand getCommitParam() {
      ParamCommand var1;
      (var1 = new ParamCommand()).addParam("tablename", "bms_Credit_cancel_dtl");
      var1.addParam("pkcolname", "creditcanceldtlid");
      var1.addParam("wheres", "usestatus=1");
      var1.addParam("updatecol", "usestatus=2,wfusestatus=1");
      return var1;
   }

   public void on_Commit(ParamCommand var1) {
      Iterator var2 = var1.getNvpairs().iterator();

      while(var2.hasNext()) {
         int var3 = Integer.valueOf(((NVPair)var2.next()).getName());
         this.setItemValue(var3, "wfusestatus", "1");
         this.setItemValue(var3, "usestatus", "2");
         this.setdbStatus(var3, 0);
      }

   }

   public boolean on_beforeCommit(int var1) {
      if (!this.getItemValue(var1, "usestatus").equals("1")) {
         this.infoMessage("细单提示", "第" + (var1 + 1) + "行不是临时状态");
         return false;
      } else {
         return true;
      }
   }
}
